--local modPath = 'FinalRushPro3'
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua');
local ScenarioFramework = import('/lua/ScenarioFramework.lua');
local Utilities = import('/lua/utilities.lua');
local Entity = import('/lua/sim/Entity.lua').Entity;
local GameCommon = import('/lua/ui/game/gamecommon.lua');
--local Aggression = import('/mods/'..modPath..'/lua/Aggression.lua'); --need to shift to agression check to prevent desync when not used.
-- Global Mod Check
local tvEn =  false	--Total Veterancy
local acuEn	= false --Blackops Adv Command Units.

local bp = GetUnitBlueprintByName("urc1901")
bp.Intel.VisionRadius = 290
bp.Economy.BuildTime = 800

local SpawnMulti
local LandSpawnDelay = {Tech1 = "", Tech2 = "", Tech3 = "", Tech4 = "", Hunter = ""}
local LandSpawnFrequency = {Tech1 = "", Tech2 = "", Tech3 = "", Tech4 = "", Hunter = "", Random = ""}
local AirSpawnDelay = {}
local AirSpawnFrequency = {}
local NavalSpawnDelay = {}
local NavalSpawnFrequency = {}

local UnitsAttackers = {
	Land = {
		Tech1 = { "url0103", "uel0103", "xsl0201", "url0107", "uel0201", "ual0201" },
		Tech2 = { "url0202", "ual0202", "uel0202", "del0204","del0204", "url0111","url0111", "url0203", "xsl0202", "xal0203" },
		Tech3 = { "url0303", "xel0305", "uel0303", "uel0303", "ual0303", "ual0303", "xrl0305", "dal0310", "xsl0303", "xsl0303" }, 
		Tech4 = { "url0402", "ual0401", "xrl0403" },
	},
	Air = {
		Tech1 = { "uaa0103", "ura0103", "xra0105", "xsa0103", "uaa0103", "ura0103" },
		Tech2 = { "daa0206", "daa0206", "uaa0203", "ura0203", "uea0203", "dra0202" },
		Tech3 = { "xaa0305", "xaa0305", "xra0305", "uaa0304", "uea0305", "xsa0304" },
		Tech4 = { "ura0401" },
	},
	Naval = {
		Tech1 = { "xss0202", "uas0201", "urs0201", "ues0201" },
		Tech2 = { "xss0202", "uas0201", "urs0201", "ues0201" },
		Tech3 = { "uas0302", "urs0302", "ues0302", "xes0307", "xss0302" },
		Tech4 = { "uas0401" },
	},
}
	
local AttackLocations = {
	Team1 = {
		Player1 = VECTOR3( 561.5, 25.9844, 706.5 ),  
		Player2 = VECTOR3( 631.5, 25.9844, 691.5 ),
		Player3 = VECTOR3( 691.5, 25.9844, 631.5 ),
		Player4 = VECTOR3( 706.5, 25.9844, 561.5 )
	},		
	Team2 = {
		Player1 = VECTOR3( 462.5, 25.9844, 316.5 ),
		Player2 = VECTOR3( 388.5, 25.9922, 327.5 ),
		Player3 = VECTOR3( 327.5, 25.9922, 388.5 ),
		Player4 = VECTOR3( 316.5, 25.9844, 462.5 )
	}
}

local StartingPlayersExistance = {
	ARMY_1 = false,
	ARMY_2 = false,
	ARMY_3 = false,
	ARMY_4 = false,
	ARMY_5 = false,
	ARMY_6 = false,
	ARMY_7 = false,
	ARMY_8 = false
}

local TentsLocation = {
	Team1 = {
		Player1 = {TentX = 565.500000, TentY = 701.500000},
		Player2 = {TentX = 627.500000, TentY = 685.500000},
		Player3 = {TentX = 687.500000, TentY = 625.500000},
		Player4 = {TentX = 703.500000, TentY = 571.500000}
	},
	Team2 = {
		Player1 = {TentX = 458.500000, TentY = 326.500000},	
		Player2 = {TentX = 392.500000, TentY = 337.500000},
		Player3 = {TentX = 331.500000,  TentY = 398.500000},
		Player4 = {TentX = 320.500000,  TentY = 456.500000}
	}
}

local Team1Count
local Team2Count

local tblSpawnStartTimes = {
	Easy = {
		Tech1 = 60,
		Tech2 = 6  * 60,
		Tech3 = 12 * 60,
		Tech4 = 18 * 60,
		Hunter = 24 * 60
		},
	Medium = {
		Tech1 = 40,
		Tech2 = 6  * 60,
		Tech3 = 12 * 60,
		Tech4 = 18 * 60,
		Hunter = 22 * 60
		},
	Hard = {
		Tech1 = 30,
		Tech2 = 5  * 60,
		Tech3 = 10 * 60,
		Tech4 = 16 * 60,
		Hunter = 18 * 60
		},
	Insane = {
		Tech1 = 10,
		Tech2 = 4  * 60,
		Tech3 = 8 * 60,
		Tech4 = 12 * 60,
		Hunter = 16 * 60
		},
}

local tblSpawnFrequency = {
	Easy = {
		Tech1 = 6,
		Tech2 = 6,
		Tech3 = 6,
		Tech4 = 30,
		Hunter = 4 * 60,
		Random = 90
		},
	Medium = {
		Tech1 = 6,
		Tech2 = 6,
		Tech3 = 6,
		Tech4 = 20,
		Hunter = 3 * 60,
		Random = 70
		},
	Hard = {
		Tech1 = 6,
		Tech2 = 10,
		Tech3 = 10,
		Tech4 = 15,
		Hunter = 2 * 60,
		Random = 50
		},
	Insane = {
		Tech1 = 6,
		Tech2 = 6,
		Tech3 = 6,
		Tech4 = 10,
		Hunter = 90,
		Random = 30
		},
}

local Aggro = {
	Team1 = {
		Player1 = 0,
		Player2 = 0,
		Player3 = 0,
		Player4 = 0
	},
	Team2 = {
		Player1 = 0,
		Player2 = 0,
		Player3 = 0,
		Player4 = 0
	}
}

local TableUnitID = {
	Tech1 = { "ual0201", "ual0103", "url0107", "url0103", "uel0201", "uel0103", "xsl0201", "xsl0103" },
	Tech2 = { "xal0203", "ual0202", "ual0111", "url0203", "url0202", "url0111", "drl0204", "uel0203", "del0204", "uel0202", "uel0111", "uel0303", "xsl0202", "xsl0203"},
	Tech3 = { "ual0303", "xal0305", "xrl0305", "url0303", "xel0305", "xsl0303", "xsl0305"},
	Aggro = { "ual0304", "url0304", "uel0304", "xsl0304", "dal0310" }
}

function OnPopulate()
	ScenarioUtils.InitializeArmies()
    if (ScenarioInfo.Options.opt_tents == nil) then
		ScenarioInfo.Options.opt_tents = 0;
	end
    if (ScenarioInfo.Options.opt_Teleport == nil) then
		ScenarioInfo.Options.opt_Teleport = 0;
	end
	if (ScenarioInfo.Options.opt_timeunlocked == nil) then
		ScenarioInfo.Options.opt_timeunlocked = 0;
	end
	if (ScenarioInfo.Options.opt_landforce == nil) then
		ScenarioInfo.Options.opt_landforce = 0;
	end
	if (ScenarioInfo.Options.opt_airforce == nil) then
		ScenarioInfo.Options.opt_airforce = 0;
	end
	if (ScenarioInfo.Options.opt_navalforce == nil) then
		ScenarioInfo.Options.opt_navalforce = 0;
	end
	if (ScenarioInfo.Options.opt_AutoReclaim == nil) then
		ScenarioInfo.Options.opt_AutoReclaim = 0;
	end
	if (ScenarioInfo.Options.opt_Randomness == nil) then
		ScenarioInfo.Options.opt_Randomness = 0;
	end

if ScenarioInfo.Options.opt_navalforce == 0 then
	ScenarioFramework.SetPlayableArea('AREA_1' , false)
else
	ScenarioFramework.SetPlayableArea('AREA_2' , false)
end	



CreateStartingPlayersExistance()
GetTeamSize()
ResetStartingRestrictions()
spawntents()
spawnlighthouse()
unlockovertime()
Survival()
TeleportCheck()
ForkThread(Info)
end

function OnStart(self) 
end

--spawns the civilian lighthouse
spawnlighthouse = function()
    local light1 = CreateUnitHPR( "urc1901", "ARMY_9", 268.316323, 25.730654, 756.078125, 0,0,0)
    local light2 = CreateUnitHPR( "urc1901", "ARMY_9", 761.560150, 25.724628, 275.622614, 0,0,0)
    light1:SetReclaimable(false);
    light1:SetCanTakeDamage(false);
	light1:SetDoNotTarget(true); 
    light1:SetCanBeKilled(false); 
    light2:SetReclaimable(false);
    light2:SetCanTakeDamage(false);
	light2:SetDoNotTarget(true); 
    light2:SetCanBeKilled(false);
 
	light2:SetCustomName("Vision Center")
	light1:SetCustomName("Vision Center")
	
	light1.OldOnCaptured = light1.OnCaptured;
	light1.OnCaptured = function(self, captor)	
		local newunit = ChangeUnitArmy(self,captor:GetArmy())
		newunit:SetReclaimable(false);
		newunit:SetCanTakeDamage(false);
		newunit:SetDoNotTarget(true);
	end
		
	light2.OldOnCaptured = light2.OnCaptured;
	light2.OnCaptured = function(self, captor)	
		local newunit = ChangeUnitArmy(self,captor:GetArmy())
		newunit:SetReclaimable(false);
		newunit:SetCanTakeDamage(false);
		newunit:SetDoNotTarget(true);
	end
		
end

--spawns tents, checks if army exists before inserting, otherwise
spawntents = function()

local spawnunit
local hive = "xrb0304"
local tent = "xeb0204"

if ScenarioInfo.Options.opt_tents == 1 then
	spawnunit = tent
else
	spawnunit = hive
end

	if ScenarioInfo.Options.opt_tents == 0 or  ScenarioInfo.Options.opt_tents == 1 then
		if(StartingPlayersExistance.ARMY_1 == true) then		
			CreateUnitHPR( spawnunit, "ARMY_1", TentsLocation.Team1.Player1.TentX, 25.984375 , TentsLocation.Team1.Player1.TentY , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_1", TentsLocation.Team1.Player1.TentX, 25.984375, TentsLocation.Team1.Player1.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_1", TentsLocation.Team1.Player1.TentX, 25.984375, TentsLocation.Team1.Player1.TentY - 4, 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_1", TentsLocation.Team1.Player1.TentX - 2, 25.984375, TentsLocation.Team1.Player1.TentY, 0,0,0)	
			CreateUnitHPR( spawnunit, "ARMY_1", TentsLocation.Team1.Player1.TentX - 2, 25.984375, TentsLocation.Team1.Player1.TentY - 2, 0,0,0)	
			CreateUnitHPR( spawnunit, "ARMY_1", TentsLocation.Team1.Player1.TentX - 2, 25.984375, TentsLocation.Team1.Player1.TentY - 4, 0,0,0)
		end			

		if(StartingPlayersExistance.ARMY_2 == true) then	
			CreateUnitHPR( spawnunit, "ARMY_2", TentsLocation.Team1.Player2.TentX, 25.984375, TentsLocation.Team1.Player2.TentY, 0,0,0)		
			CreateUnitHPR( spawnunit, "ARMY_2", TentsLocation.Team1.Player2.TentX, 25.984375, TentsLocation.Team1.Player2.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_2", TentsLocation.Team1.Player2.TentX, 25.984375, TentsLocation.Team1.Player2.TentY - 4, 0,0,0) 	
			CreateUnitHPR( spawnunit, "ARMY_2", TentsLocation.Team1.Player2.TentX + 2, 25.984375, TentsLocation.Team1.Player2.TentY, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_2", TentsLocation.Team1.Player2.TentX + 2, 25.984375, TentsLocation.Team1.Player2.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_2", TentsLocation.Team1.Player2.TentX + 2, 25.984375, TentsLocation.Team1.Player2.TentY - 4, 0,0,0)
		end
		
		if(StartingPlayersExistance.ARMY_3 == true) then
			CreateUnitHPR( spawnunit, "ARMY_3", TentsLocation.Team1.Player3.TentX, 25.984375, TentsLocation.Team1.Player3.TentY, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_3", TentsLocation.Team1.Player3.TentX, 25.984375, TentsLocation.Team1.Player3.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_3", TentsLocation.Team1.Player3.TentX, 25.984375, TentsLocation.Team1.Player3.TentY - 4, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_3", TentsLocation.Team1.Player3.TentX + 2, 25.984375, TentsLocation.Team1.Player3.TentY, 0,0,0) 		
			CreateUnitHPR( spawnunit, "ARMY_3", TentsLocation.Team1.Player3.TentX + 2, 25.984375, TentsLocation.Team1.Player3.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_3", TentsLocation.Team1.Player3.TentX + 2, 25.984375, TentsLocation.Team1.Player3.TentY - 4, 0,0,0)
		end
	
		if(StartingPlayersExistance.ARMY_4 == true) then
			CreateUnitHPR( spawnunit, "ARMY_4", TentsLocation.Team1.Player4.TentX, 25.984375, TentsLocation.Team1.Player4.TentY, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_4", TentsLocation.Team1.Player4.TentX, 25.984375, TentsLocation.Team1.Player4.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_4", TentsLocation.Team1.Player4.TentX, 25.984375, TentsLocation.Team1.Player4.TentY - 4, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_4", TentsLocation.Team1.Player4.TentX + 2, 25.984375, TentsLocation.Team1.Player4.TentY, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_4", TentsLocation.Team1.Player4.TentX + 2, 25.984375, TentsLocation.Team1.Player4.TentY - 2, 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_4", TentsLocation.Team1.Player4.TentX + 2, 25.984375, TentsLocation.Team1.Player4.TentY - 4, 0,0,0) 
		end

		if(StartingPlayersExistance.ARMY_5 == true) then
			CreateUnitHPR( spawnunit, "ARMY_5", TentsLocation.Team2.Player1.TentX, 25.984375, TentsLocation.Team2.Player1.TentY , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_5", TentsLocation.Team2.Player1.TentX, 25.984375, TentsLocation.Team2.Player1.TentY - 2 , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_5", TentsLocation.Team2.Player1.TentX, 25.984375, TentsLocation.Team2.Player1.TentY - 4 , 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_5", TentsLocation.Team2.Player1.TentX + 2, 25.984375, TentsLocation.Team2.Player1.TentY , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_5", TentsLocation.Team2.Player1.TentX + 2, 25.984375, TentsLocation.Team2.Player1.TentY - 2 , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_5", TentsLocation.Team2.Player1.TentX + 2, 25.984375, TentsLocation.Team2.Player1.TentY - 4 , 0,0,0)
		end

		if(StartingPlayersExistance.ARMY_6 == true) then
			CreateUnitHPR( spawnunit, "ARMY_6", TentsLocation.Team2.Player2.TentX, 25.992188, TentsLocation.Team2.Player2.TentY  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_6", TentsLocation.Team2.Player2.TentX, 25.992188, TentsLocation.Team2.Player2.TentY - 2  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_6", TentsLocation.Team2.Player2.TentX, 25.992188, TentsLocation.Team2.Player2.TentY - 4  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_6", TentsLocation.Team2.Player2.TentX - 2, 25.992188, TentsLocation.Team2.Player2.TentY  , 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_6", TentsLocation.Team2.Player2.TentX - 2, 25.992188, TentsLocation.Team2.Player2.TentY - 2  , 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_6", TentsLocation.Team2.Player2.TentX - 2, 25.992188, TentsLocation.Team2.Player2.TentY - 4  , 0,0,0)
		end
	
		if(StartingPlayersExistance.ARMY_7 == true) then
			CreateUnitHPR( spawnunit, "ARMY_7", TentsLocation.Team2.Player3.TentX, 25.992188, TentsLocation.Team2.Player3.TentY  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_7", TentsLocation.Team2.Player3.TentX, 25.992188, TentsLocation.Team2.Player3.TentY - 2 , 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_7", TentsLocation.Team2.Player3.TentX, 25.992188, TentsLocation.Team2.Player3.TentY - 4  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_7", TentsLocation.Team2.Player3.TentX - 2, 25.992188, TentsLocation.Team2.Player3.TentY  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_7", TentsLocation.Team2.Player3.TentX - 2, 25.992188, TentsLocation.Team2.Player3.TentY - 2  , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_7", TentsLocation.Team2.Player3.TentX - 2, 25.992188, TentsLocation.Team2.Player3.TentY - 4  , 0,0,0)  
		end
	
		if(StartingPlayersExistance.ARMY_8 == true) then
			CreateUnitHPR( spawnunit, "ARMY_8", TentsLocation.Team2.Player4.TentX, 25.984375, TentsLocation.Team2.Player4.TentY , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_8", TentsLocation.Team2.Player4.TentX, 25.984375, TentsLocation.Team2.Player4.TentY - 2 , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_8", TentsLocation.Team2.Player4.TentX, 25.984375, TentsLocation.Team2.Player4.TentY - 4, 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_8", TentsLocation.Team2.Player4.TentX - 2, 25.984375, TentsLocation.Team2.Player4.TentY, 0,0,0) 
			CreateUnitHPR( spawnunit, "ARMY_8", TentsLocation.Team2.Player4.TentX - 2, 25.984375, TentsLocation.Team2.Player4.TentY - 2 , 0,0,0)
			CreateUnitHPR( spawnunit, "ARMY_8", TentsLocation.Team2.Player4.TentX - 2, 25.984375, TentsLocation.Team2.Player4.TentY - 4 , 0,0,0)
		end
	end
end

--given a player returns a proper username
getUsername = function(army)
	return GetArmyBrain(army).Nickname;
end

unlockovertime = function()
if (ScenarioInfo.Options.opt_timeunlocked == 0) then
	else
		local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            AddBuildRestriction(index, categories.TECH3)
			AddBuildRestriction(index, categories.TECH2)
			AddBuildRestriction(index, categories.EXPERIMENTAL)
		end
	
		ForkThread(enableT2)
		ForkThread(enableT3)
		ForkThread(enableEXP)
	end
end

enableT2 = function()
    getunlocktime = unlockwait()
    LOG("Waiting for T2 - ", getunlocktime)
    WaitSeconds(getunlocktime)
    local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            RemoveBuildRestriction(index, categories.TECH2)
		end
		transportscoutonly()
		ResetStartingRestrictions()
	PrintText("Tech 2 Enabled", 20, "ffffffff", 5, 'center');
end	

enableT3 = function()
	getunlocktime = unlockwait()	
    LOG("Waiting for t3 - ", getunlocktime * 2)
    WaitSeconds(getunlocktime * 2)
    local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            RemoveBuildRestriction(index, categories.TECH3)
		end
	transportscoutonly()
	ResetStartingRestrictions()
	PrintText("Tech 3 Enabled", 20, "ffffffff", 5, 'center');
end	

enableEXP = function()
	getunlocktime = unlockwait()	
    LOG("Waiting for t4 - ", getunlocktime * 3)
    WaitSeconds(getunlocktime * 3)
    local tblArmies = ListArmies() 
        for index, name in tblArmies do 
            RemoveBuildRestriction(index, categories.EXPERIMENTAL)
		end
	transportscoutonly()
	ResetStartingRestrictions()
	PrintText("Experimentals Enabled", 20, "ffffffff", 5, 'center');
end	

unlockwait = function()
	if (ScenarioInfo.Options.opt_timeunlocked == 1) then
		return 60 * 5
    end
	if (ScenarioInfo.Options.opt_timeunlocked == 2) then
		return 60 * 8
	end
	if (ScenarioInfo.Options.opt_timeunlocked == 3) then
		return 60 * 10
	end
	if (ScenarioInfo.Options.opt_timeunlocked == 4) then
		return 60 * 15
	end
end

ResetStartingRestrictions = function()
	if ScenarioInfo.Options.RestrictedCategories == nil then
		LOG("No Build Restrictions")
	else
		for key, value in ScenarioInfo.Options.RestrictedCategories do
			local tblArmies = ListArmies() 
			for index, name in tblArmies do 
				if value == "PRODSC1" then
					AddBuildRestriction(index, categories.PRODUCTSC1)
				elseif value == "PRODFA" then
					AddBuildRestriction(index, categories.PRODUCTFA)
				elseif value == "PRODDL" then
					-- AddBuildRestriction(index, categories.PRODUCTDL)
				elseif value == "UEF" then
					AddBuildRestriction(index, categories.UEF)
				elseif value == "CYBRAN" then
					AddBuildRestriction(index, categories.CYBRAN)
				elseif value == "AEON" then
					AddBuildRestriction(index, categories.AEON)
				elseif value == "SERAPHIM" then
					AddBuildRestriction(index, categories.SERAPHIM)
				elseif value == "T1" then
					AddBuildRestriction(index, categories.TECH1)
				elseif value == "T2" then
					AddBuildRestriction(index, categories.TECH2)
				elseif value == "T3" then
					AddBuildRestriction(index, categories.TECH3)
				elseif value == "EXPERIMENTAL" then
					AddBuildRestriction(index, categories.EXPERIMENTAL)
				elseif value == "NAVAL" then
					AddBuildRestriction(index, categories.NAVAL)
				elseif value == "LAND" then
					AddBuildRestriction(index, categories.LAND)
				elseif value == "AIR" then
					AddBuildRestriction(index, categories.AIR)
				elseif value == "NUKE" then
					AddBuildRestriction(index, categories.NUKE)
					AddBuildRestriction(index, categories.ues0304) --UEF T3 Strategic Missile Submarine: Ace
					AddBuildRestriction(index, categories.urs0304) --Cybran T3 Strategic Missile Submarine: Plan B	
					AddBuildRestriction(index, categories.uas0304) --Aeon T3 Strategic Missile Submarine: Silencer
					AddBuildRestriction(index, categories.xsa0402) --Seraphim EX Experimental Bomber: Ahwassa
					AddBuildRestriction(index, categories.xsb2401) --Seraphim EX Experimental Missile Launcher: Yolona Oss
				elseif value == "GAMEENDERS" then
					AddBuildRestriction(index, categories.uab2305)
					AddBuildRestriction(index, categories.ueb2305)
					AddBuildRestriction(index, categories.urb2305)
					AddBuildRestriction(index, categories.xsb2305)
					AddBuildRestriction(index, categories.xab2307)
					AddBuildRestriction(index, categories.ueb2302)
					AddBuildRestriction(index, categories.uab2302)
					AddBuildRestriction(index, categories.urb2302)
					AddBuildRestriction(index, categories.xsb2302)
					AddBuildRestriction(index, categories.ues0304) --UEF T3 Strategic Missile Submarine: Ace
					AddBuildRestriction(index, categories.urs0304) --Cybran T3 Strategic Missile Submarine: Plan B	
					AddBuildRestriction(index, categories.uas0304) --Aeon T3 Strategic Missile Submarine: Silencer
					AddBuildRestriction(index, categories.xsa0402) --Seraphim EX Experimental Bomber: Ahwassa
					AddBuildRestriction(index, categories.ueb2401) --UEF EX Experimental Artillery: Mavor
					AddBuildRestriction(index, categories.url0401) --Cybran EX Experimental Mobile Rapid-Fire Artillery: Scathis
					AddBuildRestriction(index, categories.xsb2401) --Seraphim EX Experimental Missile Launcher: Yolona Oss
				elseif value == "BUBBLES" then
					AddBuildRestriction(index, categories.SHIELD)
				elseif value == "INTEL" then
					AddBuildRestriction(index, categories.INTELLIGENCE)
				elseif value == "SUPCOM" then
					AddBuildRestriction(index, categories.SUBCOMMANDER)
				elseif value == "FABS" then
					AddBuildRestriction(index, categories.MASSFABRICATION)
				end
			end
		end
	end
end

createcivpararadar = function()
	local para1 = CreateUnitHPR("xab1401", "ARMY_9", 0, 0, 0, 0,0,0)
	local para2 = CreateUnitHPR("xab1401", "ARMY_9", 1024, 0, 1024, 0,0,0)
	local radar1 = CreateUnitHPR("uab3104", "ARMY_9", 0, 0, 0, 0,0,0)
	local radar2 = CreateUnitHPR("uab3104", "ARMY_9", 1024, 0, 1024, 0,0,0)

	canttouchthis(para1)
	canttouchthis(para2)
	canttouchthis(radar1)
	canttouchthis(radar2)
end

canttouchthis = function(unit)
	unit:SetReclaimable(false);
	unit:SetCanTakeDamage(false);
	unit:SetDoNotTarget(true); 
    unit:SetCanBeKilled(false); 
    unit:SetCapturable(false); 
    unit:SetReclaimable(false);
end

EnemyAttackerSize = function()
	local enemynum
	for index, brain in ArmyBrains do
		if brain.Name == "ARMY_9" then
			enemynum = brain:GetArmyStat("UnitCap_Current", 0.0).Value
		end
	end
	return enemynum + 150
end


Survival = function()	
	local tblArmies = ListArmies() 
	for index, name in tblArmies do
		SetAlliance(index, "ARMY_9", 'Enemy')
		AddBuildRestriction(index, categories.AIR)
		AddBuildRestriction(index, categories.WALL)
	end
	createcivpararadar()
	ForkThread(RunBattle)
	ForkThread(CommanderWaterPain)
end

function CreateStartingPlayersExistance()
	if not ScenarioInfo.ArmySetup["ARMY_1"] == false then
		StartingPlayersExistance.ARMY_1 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_2"] == false then
		StartingPlayersExistance.ARMY_2 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_3"] == false then
		StartingPlayersExistance.ARMY_3 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_4"] == false then
		StartingPlayersExistance.ARMY_4 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_5"] == false then
		StartingPlayersExistance.ARMY_5 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_6"] == false then
		StartingPlayersExistance.ARMY_6 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_7"] == false then
		StartingPlayersExistance.ARMY_7 = true
	end
	if not ScenarioInfo.ArmySetup["ARMY_8"] == false then
		StartingPlayersExistance.ARMY_8 = true
	end
end

Info = function()
	--LOG("----------------------------")
	--WaitSeconds(5)
	--LOG(Aggression.ReturnAggro())
end

RunBattle = function()
	tvEn  = 	IsTotalVetEnabled() 	--Total Veterancy
	acuEn = 	IsBLackOpsAcusEnabled() --Blackops Adv Command Units.
	
	if ScenarioInfo.Options.opt_landforce == 1 then
		LandSpawnDelay.Tech1 = tblSpawnStartTimes.Easy.Tech1
		LandSpawnDelay.Tech2 = tblSpawnStartTimes.Easy.Tech2
		LandSpawnDelay.Tech3 = tblSpawnStartTimes.Easy.Tech3
		LandSpawnDelay.Tech4 = tblSpawnStartTimes.Easy.Tech4
		LandSpawnDelay.Hunter = tblSpawnStartTimes.Easy.Hunter
		LandSpawnFrequency.Tech1 = tblSpawnFrequency.Easy.Tech1
		LandSpawnFrequency.Tech2 = tblSpawnFrequency.Easy.Tech2
		LandSpawnFrequency.Tech3 = tblSpawnFrequency.Easy.Tech3
		LandSpawnFrequency.Tech4 = tblSpawnFrequency.Easy.Tech4
		LandSpawnFrequency.Hunter = tblSpawnFrequency.Easy.Hunter
		LandSpawnFrequency.Random = tblSpawnFrequency.Easy.Random
	elseif ScenarioInfo.Options.opt_landforce == 2 then
		LandSpawnDelay.Tech1 = tblSpawnStartTimes.Medium.Tech1
		LandSpawnDelay.Tech2 = tblSpawnStartTimes.Medium.Tech2
		LandSpawnDelay.Tech3 = tblSpawnStartTimes.Medium.Tech3
		LandSpawnDelay.Tech4 = tblSpawnStartTimes.Medium.Tech4
		LandSpawnDelay.Hunter = tblSpawnStartTimes.Medium.Hunter
		LandSpawnFrequency.Tech1 = tblSpawnFrequency.Medium.Tech1
		LandSpawnFrequency.Tech2 = tblSpawnFrequency.Medium.Tech2
		LandSpawnFrequency.Tech3 = tblSpawnFrequency.Medium.Tech3
		LandSpawnFrequency.Tech4 = tblSpawnFrequency.Medium.Tech4
		LandSpawnFrequency.Hunter = tblSpawnFrequency.Medium.Hunter
		LandSpawnFrequency.Random = tblSpawnFrequency.Medium.Random
	elseif ScenarioInfo.Options.opt_landforce == 3 then
		LandSpawnDelay.Tech1 = tblSpawnStartTimes.Hard.Tech1
		LandSpawnDelay.Tech2 = tblSpawnStartTimes.Hard.Tech2
		LandSpawnDelay.Tech3 = tblSpawnStartTimes.Hard.Tech3
		LandSpawnDelay.Tech4 = tblSpawnStartTimes.Hard.Tech4
		LandSpawnDelay.Hunter = tblSpawnStartTimes.Hard.Hunter
		LandSpawnFrequency.Tech1 = tblSpawnFrequency.Hard.Tech1
		LandSpawnFrequency.Tech2 = tblSpawnFrequency.Hard.Tech2
		LandSpawnFrequency.Tech3 = tblSpawnFrequency.Hard.Tech3
		LandSpawnFrequency.Tech4 = tblSpawnFrequency.Hard.Tech4
		LandSpawnFrequency.Hunter = tblSpawnFrequency.Hard.Hunter
		LandSpawnFrequency.Random = tblSpawnFrequency.Hard.Random
	elseif ScenarioInfo.Options.opt_landforce == 4 then
		LandSpawnDelay.Tech1 = tblSpawnStartTimes.Insane.Tech1
		LandSpawnDelay.Tech2 = tblSpawnStartTimes.Insane.Tech2
		LandSpawnDelay.Tech3 = tblSpawnStartTimes.Insane.Tech3
		LandSpawnDelay.Tech4 = tblSpawnStartTimes.Insane.Tech4
		LandSpawnDelay.Hunter = tblSpawnStartTimes.Insane.Hunter
		LandSpawnFrequency.Tech1 = tblSpawnFrequency.Insane.Tech1
		LandSpawnFrequency.Tech2 = tblSpawnFrequency.Insane.Tech2
		LandSpawnFrequency.Tech3 = tblSpawnFrequency.Insane.Tech3
		LandSpawnFrequency.Tech4 = tblSpawnFrequency.Insane.Tech4
		LandSpawnFrequency.Hunter = tblSpawnFrequency.Insane.Hunter
		LandSpawnFrequency.Random = tblSpawnFrequency.Insane.Random
	end
	
	if ScenarioInfo.Options.opt_airforce == 1 then
		AirSpawnDelay.Tech1 = tblSpawnStartTimes.Easy.Tech1
		AirSpawnDelay.Tech2 = tblSpawnStartTimes.Easy.Tech2
		AirSpawnDelay.Tech3 = tblSpawnStartTimes.Easy.Tech3
		AirSpawnDelay.Tech4 = tblSpawnStartTimes.Easy.Tech4
		AirSpawnDelay.Hunter = tblSpawnStartTimes.Easy.Hunter
		AirSpawnFrequency.Tech1 = tblSpawnFrequency.Easy.Tech1
		AirSpawnFrequency.Tech2 = tblSpawnFrequency.Easy.Tech2
		AirSpawnFrequency.Tech3 = tblSpawnFrequency.Easy.Tech3
		AirSpawnFrequency.Tech4 = tblSpawnFrequency.Easy.Tech4
		AirSpawnFrequency.Hunter = tblSpawnFrequency.Easy.Hunter
		AirSpawnFrequency.Random = tblSpawnFrequency.Easy.Random
	elseif ScenarioInfo.Options.opt_airforce == 2 then
		AirSpawnDelay.Tech1 = tblSpawnStartTimes.Medium.Tech1
		AirSpawnDelay.Tech2 = tblSpawnStartTimes.Medium.Tech2
		AirSpawnDelay.Tech3 = tblSpawnStartTimes.Medium.Tech3
		AirSpawnDelay.Tech4 = tblSpawnStartTimes.Medium.Tech4
		AirSpawnDelay.Hunter = tblSpawnStartTimes.Medium.Hunter
		AirSpawnFrequency.Tech1 = tblSpawnFrequency.Medium.Tech1
		AirSpawnFrequency.Tech2 = tblSpawnFrequency.Medium.Tech2
		AirSpawnFrequency.Tech3 = tblSpawnFrequency.Medium.Tech3
		AirSpawnFrequency.Tech4 = tblSpawnFrequency.Medium.Tech4
		AirSpawnFrequency.Hunter = tblSpawnFrequency.Medium.Hunter
		AirSpawnFrequency.Random = tblSpawnFrequency.Medium.Random
	elseif ScenarioInfo.Options.opt_airforce == 3 then
		AirSpawnDelay.Tech1 = tblSpawnStartTimes.Hard.Tech1
		AirSpawnDelay.Tech2 = tblSpawnStartTimes.Hard.Tech2
		AirSpawnDelay.Tech3 = tblSpawnStartTimes.Hard.Tech3
		AirSpawnDelay.Tech4 = tblSpawnStartTimes.Hard.Tech4
		AirSpawnDelay.Hunter = tblSpawnStartTimes.Hard.Hunter
		AirSpawnFrequency.Tech1 = tblSpawnFrequency.Hard.Tech1
		AirSpawnFrequency.Tech2 = tblSpawnFrequency.Hard.Tech2
		AirSpawnFrequency.Tech3 = tblSpawnFrequency.Hard.Tech3
		AirSpawnFrequency.Tech4 = tblSpawnFrequency.Hard.Tech4
		AirSpawnFrequency.Hunter = tblSpawnFrequency.Hard.Hunter
		AirSpawnFrequency.Random = tblSpawnFrequency.Hard.Random
	elseif ScenarioInfo.Options.opt_airforce == 4 then
		AirSpawnDelay.Tech1 = tblSpawnStartTimes.Insane.Tech1
		AirSpawnDelay.Tech2 = tblSpawnStartTimes.Insane.Tech2
		AirSpawnDelay.Tech3 = tblSpawnStartTimes.Insane.Tech3
		AirSpawnDelay.Tech4 = tblSpawnStartTimes.Insane.Tech4
		AirSpawnDelay.Hunter = tblSpawnStartTimes.Insane.Hunter
		AirSpawnFrequency.Tech1 = tblSpawnFrequency.Insane.Tech1
		AirSpawnFrequency.Tech2 = tblSpawnFrequency.Insane.Tech2
		AirSpawnFrequency.Tech3 = tblSpawnFrequency.Insane.Tech3
		AirSpawnFrequency.Tech4 = tblSpawnFrequency.Insane.Tech4
	end
	
	
	if ScenarioInfo.Options.opt_navalforce == 1 then
		NavalSpawnDelay.Tech1 = tblSpawnStartTimes.Easy.Tech1
		NavalSpawnDelay.Tech2 = tblSpawnStartTimes.Easy.Tech2
		NavalSpawnDelay.Tech3 = tblSpawnStartTimes.Easy.Tech3
		NavalSpawnDelay.Tech4 = tblSpawnStartTimes.Easy.Tech4
		NavalSpawnDelay.Hunter = tblSpawnStartTimes.Easy.Hunter
		NavalSpawnFrequency.Tech1 = tblSpawnFrequency.Easy.Tech1
		NavalSpawnFrequency.Tech2 = tblSpawnFrequency.Easy.Tech2
		NavalSpawnFrequency.Tech3 = tblSpawnFrequency.Easy.Tech3
		NavalSpawnFrequency.Tech4 = tblSpawnFrequency.Easy.Tech4
		NavalSpawnFrequency.Hunter = tblSpawnFrequency.Easy.Hunter
		NavalSpawnFrequency.Random = tblSpawnFrequency.Easy.Random
	elseif ScenarioInfo.Options.opt_navalforce == 2 then
		NavalSpawnDelay.Tech1 = tblSpawnStartTimes.Medium.Tech1
		NavalSpawnDelay.Tech2 = tblSpawnStartTimes.Medium.Tech2
		NavalSpawnDelay.Tech3 = tblSpawnStartTimes.Medium.Tech3
		NavalSpawnDelay.Tech4 = tblSpawnStartTimes.Medium.Tech4
		NavalSpawnDelay.Hunter = tblSpawnStartTimes.Medium.Hunter
		NavalSpawnFrequency.Tech1 = tblSpawnFrequency.Medium.Tech1
		NavalSpawnFrequency.Tech2 = tblSpawnFrequency.Medium.Tech2
		NavalSpawnFrequency.Tech3 = tblSpawnFrequency.Medium.Tech3
		NavalSpawnFrequency.Tech4 = tblSpawnFrequency.Medium.Tech4
		NavalSpawnFrequency.Hunter = tblSpawnFrequency.Medium.Hunter
		NavalSpawnFrequency.Random = tblSpawnFrequency.Medium.Random
	elseif ScenarioInfo.Options.opt_navalforce == 3 then
		NavalSpawnDelay.Tech1 = tblSpawnStartTimes.Hard.Tech1
		NavalSpawnDelay.Tech2 = tblSpawnStartTimes.Hard.Tech2
		NavalSpawnDelay.Tech3 = tblSpawnStartTimes.Hard.Tech3
		NavalSpawnDelay.Tech4 = tblSpawnStartTimes.Hard.Tech4
		NavalSpawnDelay.Hunter = tblSpawnStartTimes.Hard.Hunter
		NavalSpawnFrequency.Tech1 = tblSpawnFrequency.Hard.Tech1
		NavalSpawnFrequency.Tech2 = tblSpawnFrequency.Hard.Tech2
		NavalSpawnFrequency.Tech3 = tblSpawnFrequency.Hard.Tech3
		NavalSpawnFrequency.Tech4 = tblSpawnFrequency.Hard.Tech4
		NavalSpawnFrequency.Hunter = tblSpawnFrequency.Hard.Hunter
		NavalSpawnFrequency.Random = tblSpawnFrequency.Hard.Random
	elseif ScenarioInfo.Options.opt_navalforce == 4 then
		NavalSpawnDelay.Tech1 = tblSpawnStartTimes.Insane.Tech1
		NavalSpawnDelay.Tech2 = tblSpawnStartTimes.Insane.Tech2
		NavalSpawnDelay.Tech3 = tblSpawnStartTimes.Insane.Tech3
		NavalSpawnDelay.Tech4 = tblSpawnStartTimes.Insane.Tech4
		NavalSpawnDelay.Hunter = tblSpawnStartTimes.Insane.Hunter
		NavalSpawnFrequency.Tech1 = tblSpawnFrequency.Insane.Tech1
		NavalSpawnFrequency.Tech2 = tblSpawnFrequency.Insane.Tech2
		NavalSpawnFrequency.Tech3 = tblSpawnFrequency.Insane.Tech3
		NavalSpawnFrequency.Tech4 = tblSpawnFrequency.Insane.Tech4
	end
	
	ForkThread(RandomEvents)
	ForkThread(AutoResourceThread)
	
	if ScenarioInfo.Options.opt_landforce > 0 then	
		ForkThread(LandSpawnT1)
		ForkThread(LandSpawnT2)
		ForkThread(LandSpawnT3)
		ForkThread(LandSpawnT4)
		ForkThread(SpawnerHunters)	
	end
	if ScenarioInfo.Options.opt_airforce > 0 then	
		ForkThread(AirSpawnT1)
		ForkThread(AirSpawnT2)
		ForkThread(AirSpawnT3)
		ForkThread(AirSpawnT4)
	end
	if ScenarioInfo.Options.opt_navalforce > 0 then	
		--ForkThread(NavalSpawnT1)
		ForkThread(NavalSpawnT2)
		ForkThread(NavalSpawnT3)
		ForkThread(NavalSpawnT4)
	end

end

AggressionCheck = function()
	while true do
		CompileAggression()
		WaitSeconds(2)
	end
end

LandSpawnT1 = function()
	WaitSeconds(LandSpawnDelay.Tech1)
	PrintText("Tech 1 LAND inbound", 20, "ffffffff", 5, 'center')
	while GetGameTimeSeconds() < LandSpawnDelay.Tech2 do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech1", "Land")
		end
		WaitSeconds(LandSpawnFrequency.Tech1)		
	end
end

LandSpawnT2 = function()
	WaitSeconds(LandSpawnDelay.Tech2)
	PrintText("Tech 2 LAND inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech2", "Land")
		end
		WaitSeconds(LandSpawnFrequency.Tech2)		
	end
end

LandSpawnT3 = function()
	WaitSeconds(LandSpawnDelay.Tech3)
	PrintText("Tech 3 LAND inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech3", "Land")
		end
		WaitSeconds(LandSpawnFrequency.Tech3)		
	end
end

LandSpawnT4 = function()
	WaitSeconds(LandSpawnDelay.Tech4)
	PrintText("Tech 4 LAND inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech4", "Land")
		end
		WaitSeconds(LandSpawnFrequency.Tech4)		
	end
end

AirSpawnT1 = function()
	WaitSeconds(AirSpawnDelay.Tech1)
	PrintText("Tech 1 AIR inbound", 20, "ffffffff", 5, 'center')
	while GetGameTimeSeconds() < AirSpawnDelay.Tech2 do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech1", "Air")
		end
		WaitSeconds(AirSpawnFrequency.Tech1)		
	end
end

AirSpawnT2 = function()
	WaitSeconds(AirSpawnDelay.Tech2)
	PrintText("Tech 2 AIR inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech2", "Air")
		end
		WaitSeconds(AirSpawnFrequency.Tech2)		
	end
end

AirSpawnT3 = function()
	WaitSeconds(AirSpawnDelay.Tech3)
	PrintText("Tech 3 AIR inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech3", "Air")
		end
		WaitSeconds(AirSpawnFrequency.Tech3)		
	end
end

AirSpawnT4 = function()
	WaitSeconds(AirSpawnDelay.Tech4)
	PrintText("Tech 4 AIR inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech4", "Air")
		end
		WaitSeconds(AirSpawnFrequency.Tech4)		
	end
end

NavalSpawnT1 = function()
	WaitSeconds(NavalSpawnDelay.Tech1)
	PrintText("Tech 1 NAVAL inbound", 20, "ffffffff", 5, 'center')
	while GetGameTimeSeconds() < NavalSpawnDelay.Tech2 do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech1", "Naval")
		end
		WaitSeconds(NavalSpawnFrequency.Tech1)		
	end
end

NavalSpawnT2 = function()
	WaitSeconds(NavalSpawnDelay.Tech2)
	PrintText("Tech 2 NAVAL inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech2", "Naval")
		end
		WaitSeconds(NavalSpawnFrequency.Tech2)		
	end
end

NavalSpawnT3 = function()
	WaitSeconds(NavalSpawnDelay.Tech3)
	PrintText("Tech 3 NAVAL inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech3", "Naval")
		end
		WaitSeconds(NavalSpawnFrequency.Tech3)		
	end
end

NavalSpawnT4 = function()
	WaitSeconds(NavalSpawnDelay.Tech4)
	PrintText("Tech 4 NAVAL inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(CivSpawnerProDeluxModel, "Tech4", "Naval")
		end
		WaitSeconds(NavalSpawnFrequency.Tech4)		
	end
end


SpawnerHunters = function()
	WaitSeconds(LandSpawnDelay.Hunter)
	PrintText("Hunters inbound", 20, "ffffffff", 5, 'center')
	while true do
		if EnemyAttackerSize() < ScenarioInfo.Options.UnitCap then
			ForkThread(Hunters,LandSpawnDelay.Hunter)
		end
		WaitSeconds(LandSpawnFrequency.Hunter)
	end
end

GetRandomPlayer = function(team)
	local selectplayertoattack = Random(1,4)
	local Units_FinalFight
	if team == 1 then
		if selectplayertoattack == 1 then
			Units_FinalFight = AttackLocations.Team1.Player1
		elseif selectplayertoattack == 2 then
			Units_FinalFight = AttackLocations.Team1.Player2
		elseif selectplayertoattack == 3 then
			Units_FinalFight = AttackLocations.Team1.Player3
		elseif selectplayertoattack == 4 then
			Units_FinalFight = AttackLocations.Team1.Player4
		end
	elseif team == 2 then
		if selectplayertoattack == 1 then
			Units_FinalFight = AttackLocations.Team2.Player1
		elseif selectplayertoattack == 2 then
			Units_FinalFight = AttackLocations.Team2.Player2
		elseif selectplayertoattack == 3 then
			Units_FinalFight = AttackLocations.Team2.Player3
		elseif selectplayertoattack == 4 then
			Units_FinalFight = AttackLocations.Team2.Player4
		end
	end
	return Units_FinalFight
end

function GetRandomPlayerExisted(team)
	local Units_FinalFight = false
	local selectplayertoattack
	while Units_FinalFight == false do
		selectplayertoattack = Random(1,4)
	
		if team == 1 then
			if selectplayertoattack == 1 and StartingPlayersExistance.ARMY_1 then
				Units_FinalFight = AttackLocations.Team1.Player1
				--LOG("Attacking ", getUsername("ARMY_1"))
			elseif selectplayertoattack == 2 and StartingPlayersExistance.ARMY_2 then
				Units_FinalFight = AttackLocations.Team1.Player2
				--LOG("Attacking ", getUsername("ARMY_2"))
			elseif selectplayertoattack == 3 and StartingPlayersExistance.ARMY_3 then
				Units_FinalFight = AttackLocations.Team1.Player3
				--LOG("Attacking ", getUsername("ARMY_3"))
			elseif selectplayertoattack == 4 and StartingPlayersExistance.ARMY_4 then
				Units_FinalFight = AttackLocations.Team1.Player4
				--LOG("Attacking ", getUsername("ARMY_4"))
			end
		elseif team == 2 then
			if selectplayertoattack == 1 and StartingPlayersExistance.ARMY_5 then
				Units_FinalFight = AttackLocations.Team2.Player1
				--LOG("Attacking ", getUsername("ARMY_5"))
			elseif selectplayertoattack == 2 and StartingPlayersExistance.ARMY_6 then	
				Units_FinalFight = AttackLocations.Team2.Player2
				--LOG("Attacking ", getUsername("ARMY_6"))
			elseif selectplayertoattack == 3 and StartingPlayersExistance.ARMY_7 then
				Units_FinalFight = AttackLocations.Team2.Player3
				--LOG("Attacking ", getUsername("ARMY_7"))
			elseif selectplayertoattack == 4 and StartingPlayersExistance.ARMY_8 then
				Units_FinalFight = AttackLocations.Team2.Player4
				--LOG("Attacking ", getUsername("ARMY_8"))
			end
		end
		WaitSeconds(0.1)
	end
	return Units_FinalFight
end

GetNearestCommander = function(unitgroup,range)
	local comdistable = {}
	local unitattackerpos
	local unit_pos
	local dist
	local CommandersInRange
	local commandertoattack = false
	
	for index,unitattacker in unitgroup do 
		if not unitattacker:IsDead() then
			unitattackerpos = unitattacker:GetPosition() 
            local brain = unitattacker:GetAIBrain() 
            CommandersInRange = brain:GetUnitsAroundPoint( categories.COMMAND, unitattackerpos, range, 'Enemy' ) 
		end
	end
	if CommandersInRange then
		for num, unit in CommandersInRange do
			unit_pos = unit:GetPosition()
			dist = VDist2(unitattackerpos.x,unitattackerpos.z,unit_pos.x,unit_pos.z)
			commandertoattack = unit
		end
	end
	return commandertoattack
end

function CreateUnitintoTable(UnitTable,name, TeleToLoc)
		table.insert(UnitTable, CreateUnitHPR(name, "ARMY_9", TeleToLoc.x,TeleToLoc.y,TeleToLoc.z,0,0,0))
		return UnitTable
end

CivSpawnerProDeluxModel = function(Tech,Type)
	local TeleToLand = { x = Random(476,546), y = 25.9844, z = Random(476,546) }
	
	local TeleToNavalTop = { x = Random(50,50), y = 25.9844, z = Random(70,70) }
	local TeleToNavalBottom = { x = Random(990,990), y = 25.9844, z = Random(970,970) }
	
	local TeleToAir

	if ScenarioInfo.Options.opt_navalforce == 0 then
		if Random(2) == 1 then
			TeleToAirTop = { x = 256, y = 80, z = 10 }	
			TeleToAirBottom = { x = 256, y = 80, z = 10 }	
		else
			TeleToAirTop = { x = 10, y = 80, z = 256 }	
			TeleToAirBottom = { x = 256, y = 80, z = 10 }	
		end
	else
		local randnum = Random(2)
		if randnum == 1 then
			TeleToAirTop = { x = 1020, y = 80, z = 10 }	
			TeleToAirBottom = { x = 10, y = 80, z = 1020 }		
		elseif randnum == 2 then
			TeleToAirTop = { x = 10, y = 80, z = 10 }
			TeleToAirBottom = { x = 1020, y = 80, z = 1020 }
		end
	end
	
	local AttachForceNorth = {}
	local AttackForceSouth = {}
	
	
	
	
	if Type == "Land" then
		if Tech == "Tech1" then
			for index, name in UnitsAttackers.Land.Tech1 do
				ForkThread(CreateUnitintoTable,AttachForceNorth,name, TeleToLand)
				ForkThread(CreateUnitintoTable,AttackForceSouth,name, TeleToLand)
			end
			if ScenarioInfo.Options.opt_landforce > 1 then	
				HeathMulti(AttachForceNorth,LandSpawnDelay.Tech1,ScenarioInfo.Options.opt_landforce)
				HeathMulti(AttackForceSouth,LandSpawnDelay.Tech1,ScenarioInfo.Options.opt_landforce)
			end
		elseif Tech == "Tech2" then
			for index, name in UnitsAttackers.Land.Tech2 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToLand)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToLand)
			end
			if ScenarioInfo.Options.opt_landforce > 1 then	
				HeathMulti(AttachForceNorth,LandSpawnDelay.Tech2,ScenarioInfo.Options.opt_landforce)
				HeathMulti(AttackForceSouth,LandSpawnDelay.Tech2,ScenarioInfo.Options.opt_landforce)
			end
		elseif Tech == "Tech3" then
			for index, name in UnitsAttackers.Land.Tech3 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToLand)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToLand)
			end
			if ScenarioInfo.Options.opt_landforce > 1 then	
				HeathMulti(AttachForceNorth,LandSpawnDelay.Tech3,ScenarioInfo.Options.opt_landforce)
				HeathMulti(AttackForceSouth,LandSpawnDelay.Tech3,ScenarioInfo.Options.opt_landforce)
			end
		elseif Tech == "Tech4" then
			for index, name in UnitsAttackers.Land.Tech4 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToLand)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToLand)
			end
			if ScenarioInfo.Options.opt_landforce > 1 then	
				HeathMulti(AttachForceNorth,LandSpawnDelay.Tech4,ScenarioInfo.Options.opt_landforce)
				HeathMulti(AttackForceSouth,LandSpawnDelay.Tech4,ScenarioInfo.Options.opt_landforce)
			end
		end
	elseif Type == "Air" then
		if Tech == "Tech1" then
			for index, name in UnitsAttackers.Air.Tech1 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToAirTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToAirBottom)
			end
			if ScenarioInfo.Options.opt_airforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech1,ScenarioInfo.Options.opt_airforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech1,ScenarioInfo.Options.opt_airforce)
			end
		elseif Tech == "Tech2" then
			for index, name in UnitsAttackers.Air.Tech2 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToAirTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToAirBottom)
			end
			if ScenarioInfo.Options.opt_airforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech2,ScenarioInfo.Options.opt_airforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech2,ScenarioInfo.Options.opt_airforce)
			end
		elseif Tech == "Tech3" then
			for index, name in UnitsAttackers.Air.Tech3 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToAirTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToAirBottom)
			end
			if ScenarioInfo.Options.opt_airforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech3,ScenarioInfo.Options.opt_airforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech3,ScenarioInfo.Options.opt_airforce)
			end
		elseif Tech == "Tech4" then
			for index, name in UnitsAttackers.Air.Tech4 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToAirTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToAirBottom)
			end
			if ScenarioInfo.Options.opt_airforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech4,ScenarioInfo.Options.opt_airforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech4,ScenarioInfo.Options.opt_airforce)
			end
		end
		local airmiddle = VECTOR3(TeleToLand.x, TeleToLand.x, TeleToLand.y)
		IssueAggressiveMove(AttachForceNorth,airmiddle)
		IssueAggressiveMove(AttackForceSouth,airmiddle)
	elseif Type == "Naval" then
		if Tech == "Tech1" then
			for index, name in UnitsAttackers.Naval.Tech1 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToNavalTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToNavalBottom)
				for index,unit in AttachForceNorth do 
					unit:SetMaxHealth(unit:GetMaxHealth() * 0.1)
					unit:SetHealth(unit ,unit:GetMaxHealth() * 0.1)
				end
				for index,unit in AttackForceSouth do 
					unit:SetMaxHealth(unit:GetMaxHealth() * 0.1)
					unit:SetHealth(unit ,unit:GetMaxHealth() * 0.1)
				end			
			end
			if ScenarioInfo.Options.opt_navalforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech1,ScenarioInfo.Options.opt_navalforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech1,ScenarioInfo.Options.opt_navalforce)
			end
		elseif Tech == "Tech2" then
			for index, name in UnitsAttackers.Naval.Tech2 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToNavalTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToNavalBottom)
			end
			if ScenarioInfo.Options.opt_navalforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech2,ScenarioInfo.Options.opt_navalforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech2,ScenarioInfo.Options.opt_navalforce)
			end
		elseif Tech == "Tech3" then
			for index, name in UnitsAttackers.Naval.Tech3 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToNavalTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToNavalBottom)
			end
			if ScenarioInfo.Options.opt_navalforce > 1 then	
				HeathMulti(AttachForceNorth,AirSpawnDelay.Tech3,ScenarioInfo.Options.opt_navalforce)
				HeathMulti(AttackForceSouth,AirSpawnDelay.Tech3,ScenarioInfo.Options.opt_navalforce)
			end
		elseif Tech == "Tech4" then
			for index, name in UnitsAttackers.Naval.Tech4 do
				ForkThread(CreateUnitintoTable,AttachForceNorth, TeleToNavalTop)
				ForkThread(CreateUnitintoTable,AttackForceSouth, TeleToNavalBottom)
			end
			if ScenarioInfo.Options.opt_navalforce > 1 then	
				HeathMulti(AttachForceNorth,NavalSpawnDelay.Tech4,ScenarioInfo.Options.opt_navalforce)
				HeathMulti(AttackForceSouth,NavalSpawnDelay.Tech4,ScenarioInfo.Options.opt_navalforce)
			end
		end	
	end
	
	
	RemoveWreckage(AttachForceNorth)
	RemoveWreckage(AttackForceSouth)
	
	for index,spawnunit in AttachForceNorth do 
		ForkThread(spawnEffect,spawnunit)
	end
	for index,spawnunit in AttackForceSouth do 
		ForkThread(spawnEffect,spawnunit)
	end
	
	--if Type == "Land" or Type =="Air" then
		ForkThread(ArmyAttackTarget,"North",AttachForceNorth)
		ForkThread(ArmyAttackTarget,"South",AttackForceSouth)
	--end		
	--WaitSeconds(50)
end


SpeedCurrentUnits = function()
	PrintText("Current Units Speed Boosted" , 20, "ffffffff", 5, 'center');
	local units = allUnits() 
	for index,unit in units do 
		if EntityCategoryContains(categories.LAND + categories.NAVAL, unit) and scnArmy(unit) ==  "ARMY_9" then
			unit:SetSpeedMult(2)
		end
	end
end
	
RandomEvents = function()
	local RandomFrequency
	WaitSeconds(120)
	
	if ScenarioInfo.Options.opt_landforce > 0 then	
		RandomFrequency = LandSpawnFrequency.Random
	elseif ScenarioInfo.Options.opt_airforce > 0 then	
		RandomFrequency = AirSpawnFrequency.Random
	end
	if ScenarioInfo.Options.opt_navalforce > 0 then	
		RandomFrequency = NavalSpawnFrequency.Random
	end

	while true do
		local randomnum = Random(6)
		if randomnum == 1 or randomnum == 2 then
			PrintText("Current Units Gain Health Boost" , 20, "ffffffff", 5, 'center');
			local units = allUnits()
			for index,unit in units do 
				if scnArmy(unit) ==  "ARMY_9" then
					unit:SetMaxHealth(unit:GetMaxHealth() * 2)
					unit:SetHealth(unit ,unit:GetMaxHealth() * 2)
				end
			end
		elseif randomnum == 3 then
			PrintText("Current Units Weakened" , 20, "ffffffff", 5, 'center');
			local units = allUnits()
			for index,unit in units do 
				if scnArmy(unit) ==  "ARMY_9" then
					unit:SetMaxHealth(unit:GetMaxHealth() * 0.1)
					unit:SetHealth(unit ,unit:GetMaxHealth() * 0.1)
				end
			end
		elseif randomnum == 4 or randomnum == 5 then
			SpeedCurrentUnits()
		end
		WaitSeconds(RandomFrequency)
	end
end

Hunters = function(hpincreasedelay)
	local AttackTeam = GetRandomCommander() --returns army ie. ARMY_1
	local AttackCommander = GetArmyCommander(AttackTeam)
	local Leader
	local spawnrandomcommander = Random(1,4)
	local TeleToLand = { x = Random(476,546), y = 25.9844, z = Random(476,546) }
	
	local acu_cyran
	local acu_uef
	local acu_aeon
	local acu_seraphim
	
	if acuEn == false then
		acu_cyran	 =	"url0001"
		acu_uef		 =	"uel0001"
		acu_aeon	 =	"ual0001"
		acu_seraphim =	"xsl0001"
	elseif acuEn == true then
		acu_cyran	 =	"erl0001"
		acu_uef		 =	"eel0001"
		acu_aeon	 =	"eal0001"
		acu_seraphim =	"esl0001"	
	end

	if spawnrandomcommander == 1 then
		Leader = CreateUnitHPR(acu_aeon, "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --Aeon Armored Command Unit
	elseif spawnrandomcommander == 2 then
		Leader = CreateUnitHPR(acu_cyran, "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --Cybran Armored Command Unit
	elseif spawnrandomcommander == 3 then
		Leader = CreateUnitHPR(acu_uef, "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --UEF Armored Command Unit
	elseif spawnrandomcommander == 4 then
		Leader = CreateUnitHPR(acu_seraphim, "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --Seraphim Armored Command Unit
	end
	Leader:SetCustomName("Bounty Hunter = Target: " .. getUsername(AttackTeam))
	local unit_aeon  = CreateUnitHPR("ual0301", "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --Aeon T3 Support Armored Command Unit
	local unit_cyran = CreateUnitHPR("url0301", "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --Cybran T3 Support Armored Command Unit
	local unit_uef   = CreateUnitHPR("uel0301", "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --UEF T3 Support Armored Command Unit
	local unit_sera  = CreateUnitHPR("xsl0301", "ARMY_9", TeleToLand.x,TeleToLand.y,TeleToLand.z,0,0,0)  --Seraphim T3 Support Armored Command Unit
	
	local unit_list = {Leader,unit_aeon,unit_cyran,unit_uef,unit_sera}		
	
	for index,spawnunit in unit_list do 
		ForkThread(spawnEffect,spawnunit)
		ForkThread(CommanderUpgrades,spawnunit)
	end
	
	if ScenarioInfo.Options.opt_gamemode > 3 then
		HeathMulti(unit_list,hpincreasedelay)
	end
	
	if AttackCommander == false then --team has no commander
		WaitSeconds(3)
		for index, unit in unit_list do
			ForkThread(spawnOutEffect,unit)
		end	
	else
		IssueAttack(unit_list,AttackCommander)
	
	
		while not AttackCommander:IsDead() do
		WaitSeconds(3)
		end
		PrintText("Bounty " .. getUsername(AttackTeam) .. " Collected" , 20, "ffffffff", 5, 'center');
		WaitSeconds(6)
		for index, unit in unit_list do
			ForkThread(spawnOutEffect,unit)
		end	
	end
end

CommanderUpgrades = function(unit)
	local unitid = unit:GetUnitId()
		if unitid == "ual0001" then 							--Aeon Armored Command Unit
			unit:CreateEnhancement("Shield")
			unit:CreateEnhancement("ShieldHeavy")
			unit:CreateEnhancement("HeatSink")
			unit:CreateEnhancement("CrysalisBeam")
		elseif unitid == "url0001" then 						--Cybran Armored Command Unit
			unit:CreateEnhancement("StealthGenerator")
			unit:CreateEnhancement("CloakingGenerator")
			unit:CreateEnhancement("CoolingUpgrade")
			unit:CreateEnhancement("MicrowaveLaserGenerator")
		elseif unitid == "uel0001" then 						--UEF Armored Command Unit
			unit:CreateEnhancement("DamageStablization")
			unit:CreateEnhancement("HeavyAntiMatterCannon")
			unit:CreateEnhancement("Shield")
		elseif unitid == "xsl0001" then 						--Seraphim Armored Command Unit
			unit:CreateEnhancement("BlastAttack")
			unit:CreateEnhancement("DamageStabilization")
			unit:CreateEnhancement("DamageStabilizationAdvanced")
			unit:CreateEnhancement("RateOfFire")
		elseif unitid == "eal0001" then 						--Aeon Blackops Armored Command Unit
			unit:CreateEnhancement("EXCombatEngineering")  		--combat t2
			unit:CreateEnhancement("EXAssaultEngineering")		--combat t3
			unit:CreateEnhancement("EXApocolypticEngineering")	--combat t4
			unit:CreateEnhancement("EXBeamPhason")
			unit:CreateEnhancement("EXImprovedCoolingSystem")
			unit:CreateEnhancement("EXPowerBooster")
			unit:CreateEnhancement("EXShieldBattery")
			unit:CreateEnhancement("EXActiveShielding")
			unit:CreateEnhancement("EXImprovedShieldBattery")
		elseif unitid == "erl0001" then 						--Cybran Blackops Armored Command Unit
			unit:CreateEnhancement("EXCombatEngineering")  		--combat t2
			unit:CreateEnhancement("EXAssaultEngineering")		--combat t3
			unit:CreateEnhancement("EXApocolypticEngineering")	--combat t4
			unit:CreateEnhancement("EXMasor")
			unit:CreateEnhancement("EXImprovedCoolingSystem")
			unit:CreateEnhancement("EXAdvancedEmitterArray")
			unit:CreateEnhancement("EXArmorPlating")
			unit:CreateEnhancement("EXStructuralIntegrity")
			unit:CreateEnhancement("EXCompositeMaterials")
		elseif unitid == "eel0001" then 						--UEF Blackops Armored Command Unit
			unit:CreateEnhancement("EXCombatEngineering")  		--combat t2
			unit:CreateEnhancement("EXAssaultEngineering")		--combat t3
			unit:CreateEnhancement("EXApocolypticEngineering")	--combat t4
			unit:CreateEnhancement("EXAntiMatterCannon")
			unit:CreateEnhancement("EXImprovedContainmentBottle")
			unit:CreateEnhancement("EXPowerBooster")
			unit:CreateEnhancement("EXShieldBattery")	
			unit:CreateEnhancement("EXActiveShielding")
			unit:CreateEnhancement("EXImprovedShieldBattery")
		elseif unitid == "esl0001" then 						--Seraphim Blackops Armored Command Unit
			unit:CreateEnhancement("EXCombatEngineering")  		--combat t2
			unit:CreateEnhancement("EXAssaultEngineering")		--combat t3
			unit:CreateEnhancement("EXApocolypticEngineering")	--combat t4
			unit:CreateEnhancement("EXCannonBigBall")
			unit:CreateEnhancement("EXImprovedContainmentBottle")
			unit:CreateEnhancement("EXPowerBooster")
			unit:CreateEnhancement("EXL1Lambda")	
			unit:CreateEnhancement("EXL2Lambda")
			unit:CreateEnhancement("EXL3Lambda")
		elseif unitid == "ual0301" then 						--Aeon T3 Support Armored Command Unit
		unit:CreateEnhancement("Shield") 	 					--back
		unit:CreateEnhancement("ShieldHeavy") 	 				--back
		unit:CreateEnhancement("StabilitySuppressant")  		--right
		unit:CreateEnhancement("EngineeringFocusingModule")  	--left
	elseif unitid == "url0301" then --Cybran T3 Support Armored Command Unit
		unit:CreateEnhancement("StealthGenerator")  			--back
		unit:CreateEnhancement("CloakingGenerator")  			--back
		unit:CreateEnhancement("EMPCharge")						--left
		unit:CreateEnhancement("FocusConvertor")				--right
	elseif unitid == "uel0301" then --UEF T3 Support Armored Command Unit
		unit:CreateEnhancement("AdvancedCoolingUpgrade")		--left
		unit:CreateEnhancement("HighExplosiveOrdnance")			--right
		unit:CreateEnhancement("Shield")						--back	
	elseif unitid == "xsl0301" then --Seraphim T3 Support Armored Command Unit
		unit:CreateEnhancement("DamageStabilization")			--left
		unit:CreateEnhancement("Shield")						--back
		unit:CreateEnhancement("Overcharge")					--right	
	end
end

ArmyAttackTarget = function(attackarmy,unitgroup)
	if attackarmy == "South" then
		IssueAggressiveMove(unitgroup,GetRandomPlayer(1))
		IssueAggressiveMove(unitgroup,GetRandomPlayer(1))
	elseif attackarmy == "North" then
		IssueAggressiveMove(unitgroup,GetRandomPlayer(2))
		IssueAggressiveMove(unitgroup,GetRandomPlayer(2))
	end
	
	WaitSeconds(90)
	local range = 50
	while GetNearestCommander(unitgroup,range) == false and range < 400 do
		range = range + 50
		WaitSeconds(1)
	end
	
	if GetNearestCommander(unitgroup,range) == false then
		for key, value in unitgroup do
			if not value:IsDead() then
				spawnOutEffect(value)
			end
		end
	else
		IssueAttack(unitgroup,GetNearestCommander(unitgroup,range))
		ForkThread(Killgroup,unitgroup)
	end	
end

Killgroup = function(unitgroup)
	WaitSeconds(60*6)
	for key, value in unitgroup do
		if not value:IsDead() then
			spawnOutEffect(value)
		end
	end
end

HeathMulti = function(unitgroup,hpincreasedelay,difficulty)
	local current_time = GetGameTimeSeconds()
	local hp_multi
	local TVGlevel
	local difficulty_multi
	local vetlevel
	
		if difficulty == 2 then --normal
			difficulty_multi = 0.25
			vetlevel = 2
		elseif difficulty == 3 then --hard
			difficulty_multi = 1
			vetlevel = 3
		elseif difficulty == 4 then --insane	
			difficulty_multi = 4
			vetlevel = 5
		end
		
	if tvEn == false then
		hp_multi = (current_time - hpincreasedelay) / 100 * difficulty_multi
		--LOG("muli hp: ", hp_multi)
		for key, value in unitgroup do
			value:SetVeterancy(vetlevel)
			value:SetMaxHealth(value:GetMaxHealth() * (hp_multi + 1))
			value:SetHealth(value ,value:GetMaxHealth() * (hp_multi + 1))
		end
	elseif tvEn == true then
		hp_multi = ((current_time - hpincreasedelay) / 100 * difficulty_multi)
		TVGlevel = math.floor((current_time - (hpincreasedelay / 2)) / 30 * difficulty_multi) 
		for key, value in unitgroup do
			value:AddLevels(TVGlevel)
			value:SetMaxHealth(value:GetMaxHealth() * (hp_multi + 1))
			value:SetHealth(value ,value:GetMaxHealth() * (hp_multi + 1))
		end
	end
end

allUnits = function() 
     local xmapsize = ScenarioInfo.size[1] 
     local ymapsize = ScenarioInfo.size[2] 
     local mapRect = {x0 = 0, x1 = xmapsize, y0 = 0, y1 = ymapsize} 
     units = GetUnitsInRect(mapRect) 
    return units 
end 

killUnitsOnLayer = function(layers) 
   --get all units on the map 
   local units = allUnits() 
   --if there are units on the map 
   if units and table.getn(units) > 0 then 
      for index,unit in units do 
         local delete = false 
          
         --is the unit on one of the specified layers? 
         for index,layer in layers do 
            if unit:GetCurrentLayer() == layer and EntityCategoryContains(categories.COMMAND, unit) then 
               delete = true 
            end 
         end 
                
         if  delete == true then 
            if unit and not unit:IsDead() then 
				local pos = unit:GetPosition()
				unit:SetHealth(unit ,unit:GetHealth() - (unit:GetMaxHealth() / 10))
				if unit:GetHealth() < 10 then
					unit:Kill()
				end
            end 
        end 
		end 
	end 
end 

CommanderWaterPain = function()
	while true do 
		WaitSeconds(2) 
        killUnitsOnLayer({'Water','Seabed','Sub'})
	end
end

GetRandomCommander = function()
	local army = false
	local randomnum
	while army == false do
		randomnum = Random(1,8)
		if randomnum == 1 and StartingPlayersExistance.ARMY_1 and ArmyIsOutOfGame("ARMY_1") == false then
			army = "ARMY_1"
		elseif randomnum == 2 and StartingPlayersExistance.ARMY_2 and ArmyIsOutOfGame("ARMY_2") == false then
			army = "ARMY_2"
		elseif randomnum == 3 and StartingPlayersExistance.ARMY_3 and ArmyIsOutOfGame("ARMY_3") == false then
			army = "ARMY_3"
		elseif randomnum == 4 and StartingPlayersExistance.ARMY_4 and ArmyIsOutOfGame("ARMY_4") == false then
			army = "ARMY_4"
		elseif randomnum == 5 and StartingPlayersExistance.ARMY_5 and ArmyIsOutOfGame("ARMY_5") == false then
			army = "ARMY_5"
		elseif randomnum == 6 and StartingPlayersExistance.ARMY_6 and ArmyIsOutOfGame("ARMY_6") == false then
			army = "ARMY_6"
		elseif randomnum == 7 and StartingPlayersExistance.ARMY_7 and ArmyIsOutOfGame("ARMY_7") == false then
			army = "ARMY_7"
		elseif randomnum == 8 and StartingPlayersExistance.ARMY_8 and ArmyIsOutOfGame("ARMY_8") == false then
			army = "ARMY_8"
		else
			army = false
		end
	end
	PrintText("Hunters are targeting " .. getUsername(army), 20, "ffffffff", 5, 'center');	
	return army
end

GetArmyCommander = function(army)
	local units = allUnits() 
	local commander = false
	for index,unit in units do 
		if EntityCategoryContains(categories.COMMAND, unit) and scnArmy(unit) ==  army then
			commander = unit
		end
	end
	return commander
end

--given a unit returns the army 
scnArmy = function(unit) 
   local armyIndex = unit:GetArmy() 
   return indexToArmy(armyIndex) 
end 

--given an army index returns an army 
indexToArmy = function(armyIndex) 
   local army = ListArmies()[armyIndex] 
   return army 
end 

spawnEffect = function(unit) 
   unit:PlayUnitSound('TeleportStart') 
   unit:PlayUnitAmbientSound('TeleportLoop') 
   WaitSeconds( 0.1 ) 
   unit:PlayTeleportInEffects() 
   WaitSeconds( 0.1 ) 
   unit:StopUnitAmbientSound('TeleportLoop') 
   unit:PlayUnitSound('TeleportEnd') 
end 

spawnOutEffect = function(unit) 
   unit:PlayUnitSound('TeleportStart') 
   unit:PlayUnitAmbientSound('TeleportLoop') 
   WaitSeconds( 0.1 ) 
   unit:PlayTeleportInEffects() 
   WaitSeconds( 0.1 ) 
   unit:StopUnitAmbientSound('TeleportLoop') 
   unit:PlayUnitSound('TeleportEnd') 
   unit:Destroy()
end 

function IsTotalVetEnabled()
    local ai = GetArmyBrain("ARMY_9")
	    for k,unit  in ai:GetListOfUnits( categories.STRUCTURE, false ) do
        if unit:GetBlueprint().Economy.xpValue == nil then
            LOG('TVG Disabled')
            return false
        else
			LOG('TVG Enabled')
			return true
		end
    end
end

function IsBLackOpsAcusEnabled()
	local bobp = GetUnitBlueprintByName("eal0001")
	if bobp.Economy.BuildTime  == nil then
		LOG('Blackops Disabled')
		return false
    else
		LOG('Blackops Enabled')
		return true
	end
end
	 
function RemoveWreckage(unitgroup)
	local bp
	if (ScenarioInfo.Options.opt_AutoReclaim > 0) then
		for key, unit in unitgroup do
			bp = unit:GetBlueprint()
			bp.Wreckage = nil
		end
	end
end	 

function TeleportCheck()
	if (ScenarioInfo.Options.opt_Teleport == 0) then
		ScenarioFramework.RestrictEnhancements({'Teleporter'})
	end
end	 
	 
function GetTeamSize()
	local Team1Num = 0
	local Team2Num = 0
	
	if StartingPlayersExistance.ARMY_1 then
		Team1Num = Team1Num + 1
	end
	if StartingPlayersExistance.ARMY_2 then
		Team1Num = Team1Num + 1
	end
	if StartingPlayersExistance.ARMY_3 then
		Team1Num = Team1Num + 1
	end
	if StartingPlayersExistance.ARMY_4 then
		Team1Num = Team1Num + 1
	end
	if StartingPlayersExistance.ARMY_5 then
		Team2Num = Team2Num + 1
	end
	if StartingPlayersExistance.ARMY_6 then
		Team2Num = Team2Num + 1
	end
	if StartingPlayersExistance.ARMY_7 then
		Team2Num = Team2Num + 1
	end
	if StartingPlayersExistance.ARMY_8 then
		Team2Num = Team2Num + 1
	end
	
	Team1Count = Team1Num
	Team2Count = Team2Num
	SpawnMulti = (Team1Count + Team2Count) / 8
end	 
	 
function PlayerToLoc(team, player)
	if team == 1 then
		if player == 1 then
			return AttackLocations.Team1.Player1
		elseif player == 2 then
			return AttackLocations.Team1.Player2
		elseif player == 3 then
			return AttackLocations.Team1.Player3
		elseif player == 4 then
			return AttackLocations.Team1.Player4
		end
	elseif team == 2 then
			if player == 1 then
			return AttackLocations.Team2.Player1
		elseif player == 2 then
			return AttackLocations.Team2.Player2
		elseif player == 3 then
			return AttackLocations.Team2.Player3
		elseif player == 4 then
			return AttackLocations.Team2.Player4
		end
	end
end
	
function ArmyToPlayerTeam(army)
	local data = {}
	if army == "ARMY_1" then
		data = { Team = 1, Player = 1 }
	elseif army == "ARMY_2" then
		data = { Team = 1, Player = 2 }
	elseif army == "ARMY_3" then
		data = { Team = 1, Player = 3 }
	elseif army == "ARMY_4" then
		data = { Team = 1, Player = 4 } 
	elseif army == "ARMY_5" then
		data = { Team = 2, Player = 1 } 
	elseif army == "ARMY_6" then
		data = { Team = 2, Player = 2 }
	elseif army == "ARMY_7" then
		data = { Team = 2, Player = 3 }
	elseif army == "ARMY_8" then
		data = { Team = 2, Player = 4 }
	end 	
	return data
end
	
function AutoResourceThread()
	local setmulti = 0
	if ScenarioInfo.Options.opt_AutoReclaim == 1 then
		setmulti = .25
	elseif ScenarioInfo.Options.opt_AutoReclaim == 2 then
		setmulti = .50
	elseif ScenarioInfo.Options.opt_AutoReclaim == 3 then
		setmulti = .75
	elseif ScenarioInfo.Options.opt_AutoReclaim == 4 then
		setmulti = 1
	elseif ScenarioInfo.Options.opt_AutoReclaim == 5 then
		setmulti = 1.5
	elseif ScenarioInfo.Options.opt_AutoReclaim == 6 then
		setmulti = .25
	elseif ScenarioInfo.Options.opt_AutoReclaim == 7 then
		setmulti = .5
	elseif ScenarioInfo.Options.opt_AutoReclaim == 8 then
		setmulti = .75
	elseif ScenarioInfo.Options.opt_AutoReclaim == 9 then
		setmulti = 1
	end		

	local cur = {
		config = { mass = setmulti, energy = setmulti },
		delta = { mass = {}, energy = {} }, 
		trash = nil
	}

	while true do
		WaitSeconds(0.1)
		for army, brain in ArmyBrains do
			if ArmyIsOutOfGame(army) == false then
				#brain = ArmyBrains[army]
				local mass = brain:GetArmyStat("Enemies_MassValue_Destroyed",0.0).Value
				local energy = brain:GetArmyStat("Enemies_EnergyValue_Destroyed",0.0).Value
				if cur.delta.mass[army] > 0 then
					local deltaMass = (mass - cur.delta.mass[army]) * cur.config.mass
					local deltaEnergy = (energy - cur.delta.energy[army]) * cur.config.energy
					if ScenarioInfo.Options.opt_AutoReclaim > 5 then
						brain:TakeResource('MASS', deltaMass)
						brain:TakeResource('ENERGY', deltaEnergy)
					else
						brain:GiveResource('MASS', deltaMass)
						brain:GiveResource('ENERGY', deltaEnergy)
					end
				end
				cur.delta.mass[army] = mass
				cur.delta.energy[army] = energy
			end
		end
	end
end

